## This file is a general .xdc for the Nexys4 rev B board
## To use it in a project:
## - uncomment the lines corresponding to used pins
## - rename the used ports (in each line, after get_ports) according to the top level signal names in the project


set_property PACKAGE_PIN E3 [get_ports sys_clk_in]							
set_property IOSTANDARD LVCMOS33 [get_ports sys_clk_in]
#create_clock -add -name sys_clk_in -period 10.00 -waveform {0 5} [get_ports clk_board]

set_property PACKAGE_PIN P4 [get_ports {rst_board}]
set_property IOSTANDARD LVCMOS33 [get_ports {rst_board}]

# LED 0
set_property PACKAGE_PIN T8 [get_ports {clk_is_okay}]    
set_property IOSTANDARD LVCMOS33 [get_ports {clk_is_okay}]
## LED 1	
#set_property PACKAGE_PIN V9 [get_ports {rst_out}]     
#set_property IOSTANDARD LVCMOS33 [get_ports {rst_out}]
## LED 2
#set_property PACKAGE_PIN R8 [get_ports {blank_out}]     
#set_property IOSTANDARD LVCMOS33 [get_ports {blank_out}]
        
#RGB vals
#Bank = 34, Pin name = IO_L12P_T1_MRCC_34,					Sch name = LED4
#set_property PACKAGE_PIN T5 [get_ports {BCD_out[4]}]					
#	set_property IOSTANDARD LVCMOS33 [get_ports {BCD_out[4]}]
##Bank = 34, Pin name = IO_L12N_T1_MRCC_34,					Sch	name = LED5
#set_property PACKAGE_PIN T4 [get_ports {BCD_out[5]}]					
#	set_property IOSTANDARD LVCMOS33 [get_ports {BCD_out[5]}]
#Bank = 34, Pin name = IO_L22P_T3_34,						Sch name = LED6
#set_property PACKAGE_PIN U7 [get_ports {BCD_out[0]}]					
#	set_property IOSTANDARD LVCMOS33 [get_ports {BCD_out[0]}]
##Bank = 34, Pin name = IO_L22N_T3_34,						Sch name = LED7
#set_property PACKAGE_PIN U6 [get_ports {BCD_out[1]}]					
#	set_property IOSTANDARD LVCMOS33 [get_ports {BCD_out[1]}]
#Bank = 34, Pin name = IO_L10N_T1_34,						Sch name = LED8
set_property PACKAGE_PIN V4 [get_ports {out_data[0]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[0]}]
#Bank = 34, Pin name = IO_L8N_T1_34,						Sch name = LED9
set_property PACKAGE_PIN U3 [get_ports {out_data[1]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[1]}]
#Bank = 34, Pin name = IO_L7N_T1_34,						Sch name = LED10
set_property PACKAGE_PIN V1 [get_ports {out_data[2]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[2]}]
#Bank = 34, Pin name = IO_L17P_T2_34,						Sch name = LED11
set_property PACKAGE_PIN R1 [get_ports {out_data[3]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[3]}]
#Bank = 34, Pin name = IO_L13N_T2_MRCC_34,					Sch name = LED12
set_property PACKAGE_PIN P5 [get_ports {out_data[4]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[4]}]
#Bank = 34, Pin name = IO_L7P_T1_34,						Sch name = LED13
set_property PACKAGE_PIN U1 [get_ports {out_data[5]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[5]}]
#Bank = 34, Pin name = IO_L15N_T2_DQS_34,					Sch name = LED14
set_property PACKAGE_PIN R2 [get_ports {out_data[6]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[6]}]
#Bank = 34, Pin name = IO_L15P_T2_DQS_34,					Sch name = LED15
set_property PACKAGE_PIN P2 [get_ports {out_data[7]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {out_data[7]}]
                                                   


#						Sch name = SW0
set_property PACKAGE_PIN U9 [get_ports {inp_data[0]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[0]}]
set_property PACKAGE_PIN U8 [get_ports {inp_data[1]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[1]}]
set_property PACKAGE_PIN R7 [get_ports {inp_data[2]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[2]}]
set_property PACKAGE_PIN R6 [get_ports {inp_data[3]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[3]}]
set_property PACKAGE_PIN R5 [get_ports {inp_data[4]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[4]}]
set_property PACKAGE_PIN V7 [get_ports {inp_data[5]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[5]}]
set_property PACKAGE_PIN V6 [get_ports {inp_data[6]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[6]}]
set_property PACKAGE_PIN V5 [get_ports {inp_data[7]}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_data[7]}]	


#SW13 Write enable
set_property PACKAGE_PIN T1 [get_ports {inp_wr_en}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {inp_wr_en}]
#SW14 COUNT UP
set_property PACKAGE_PIN R3 [get_ports {count_up}]					
	set_property IOSTANDARD LVCMOS33 [get_ports {count_up}]
#SW15 COUNT UP
set_property PACKAGE_PIN P3 [get_ports {latch_data}]                    
    set_property IOSTANDARD LVCMOS33 [get_ports {latch_data}]