----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 09/02/2015 05:13:42 PM
-- Design Name: 
-- Module Name: counter_testbench - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity my_mem_tb is
--  Port ( );
end my_mem_tb;

architecture Behavioral of my_mem_tb is

component mem_test_top is
PORT(
inp_addr : in std_logic_vector(12 downto 0);
inp_data : in std_logic_vector(7 downto 0);
inp_wr_en : in STD_LOGIC_VECTOR(0 DOWNTO 0);
out_data  : out std_logic_vector(7 downto 0);
sys_clk_in : in std_logic;
clk_is_okay : out std_logic;
out_clock   : out std_logic
);
end component;

signal mem_wr_en_tb   : std_logic_vector(0 downto 0);
signal clk_in_tb        : std_logic := '0';
signal rst_tb           : std_logic := '0';
signal count_val_tb     : std_logic_vector(12 downto 0);

signal mem_inp_data_tb    : std_logic_vector(7 downto 0);
signal mem_out_data_tb    : std_logic_vector(7 downto 0);
signal start_count_tb   : std_logic;
signal clk_stable_tb    : std_logic;
signal enable_writes    : std_logic;
signal out_clock_tb    : std_logic;


constant clk_half_period     : time := 5ns;
constant delay_val      : time := 100ns;

begin

mem_test_top_inst : mem_test_top
port map(
    inp_addr     => count_val_tb,
    inp_data     => mem_inp_data_tb,
    inp_wr_en    => mem_wr_en_tb,
    out_data     => mem_out_data_tb,
    sys_clk_in   => clk_in_tb,
    clk_is_okay  => clk_stable_tb,
    out_clock    => out_clock_tb
    );


clk_in_tb           <= not clk_in_tb after clk_half_period;

rst_tb              <= '0' after delay_val,
                       '1' after 200ns;
                       

process(clk_in_tb,rst_tb)
begin
    if(rst_tb = '0') then
        count_val_tb <= (others => '0');
        enable_writes <= '0';
        mem_wr_en_tb <= "0";
        mem_inp_data_tb <= (others => '0');
    elsif(rising_edge(clk_in_tb)) then
        --enable_writes <= '0';
        --mem_wr_en_tb <= "0";
        if(start_count_tb = '1') then
            if(((unsigned(count_val_tb) < 10)) and (enable_writes = '1')) then
                mem_wr_en_tb <= "1";
                count_val_tb <= std_logic_vector(unsigned(count_val_tb) + 1);
                mem_inp_data_tb <= std_logic_vector(unsigned(count_val_tb(7 downto 0)) + 100);
            elsif( unsigned(count_val_tb) > 5) then
                enable_writes <= '0';
                mem_wr_en_tb <= "0";
                count_val_tb <= std_logic_vector(unsigned(count_val_tb) - 1); 
                mem_inp_data_tb <= (others => '0'); 
            else
                enable_writes <= '1'; 
               mem_wr_en_tb <= "1";
    
            end if;     
        else
            count_val_tb <= (others => '0');
        end if;
    end if;
end process;
--rst_tb              <= '1' after delay_val,'0' after 1500*delay_val;

process(out_clock_tb,rst_tb)
begin
    if(rst_tb = '0') then
        start_count_tb      <= '0';
    elsif(rising_edge(out_clock_tb)) then
        if(clk_stable_tb = '1') then
            start_count_tb      <= '1';
        else
            start_count_tb      <= '0';
        end if;
    end if;
end process;
    



end Behavioral;
