----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 09/10/2016 04:14:23 PM
-- Design Name: 
-- Module Name: mem_test_top - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mem_test_top is
PORT(
inp_addr : in std_logic_vector(12 downto 0);
inp_data : in std_logic_vector(7 downto 0);
inp_wr_en : in STD_LOGIC_VECTOR(0 DOWNTO 0);
out_data  : out std_logic_vector(7 downto 0);
sys_clk_in : in std_logic;
clk_is_okay : out std_logic;
out_clock: out std_logic;
distrib_mem_out_data  : out std_logic_vector(7 downto 0)

);
end mem_test_top;

architecture Behavioral of mem_test_top is

--Memory component
component blk_mem_gen_0 IS
  PORT (
    clka : IN STD_LOGIC;
    ena : IN STD_LOGIC;
    wea : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    addra : IN STD_LOGIC_VECTOR(12 DOWNTO 0);
    dina : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    douta : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
  );
END component;
--Clock component
component clk_wiz_0 
 PORT (
 -- Clock in ports
  clk_in1 : IN STD_LOGIC;
  -- Clock out ports
  clk_out1: OUT STD_LOGIC;
  clk_out2 : OUT STD_LOGIC;
  locked   : OUT STD_LOGIC
 );
end component;
--distributed memory component
component dist_mem_gen_0 IS
  PORT (
    a : IN STD_LOGIC_VECTOR(12 DOWNTO 0);
    d : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    clk : IN STD_LOGIC;
    we : IN STD_LOGIC;
    spo : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
  );
END component; 
 
--Local signlas
signal clk_out1_clk_gen : std_logic;
signal clk_out2_clk_gen : std_logic;

signal out_data_distrib_mem : std_logic_vector(7 downto 0);
begin

my_clk_gen: clk_wiz_0
port map(
  clk_in1       => sys_clk_in,
  clk_out1      => clk_out1_clk_gen,
  clk_out2      => clk_out2_clk_gen,
  locked        => clk_is_okay
  );
  
my_mem_inst: blk_mem_gen_0
  port map(
  clka      => clk_out1_clk_gen,
  ena       => '1',
  wea       => inp_wr_en,
  addra     => inp_addr,
  dina      => inp_data,
  douta     => out_data
  );
  
my_distributed_mem_inst: dist_mem_gen_0
    PORT MAP (
      a     => inp_addr,
      d     => inp_data,
      clk   => clk_out1_clk_gen,
      we    => inp_wr_en(0),
      spo   => out_data_distrib_mem   --spo  => out_data_distrib_mem
    );

  
  distrib_mem_out_data <= out_data_distrib_mem;
  out_clock <= clk_out1_clk_gen;
end Behavioral;
