----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 09/10/2016 06:14:52 PM
-- Design Name: 
-- Module Name: memory_top_with_ila - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity memory_top_with_ila is
PORT(
sys_clk_in : in std_logic;
rst_board  : in std_logic;

inp_data : in std_logic_vector(7 downto 0);
inp_wr_en : in STD_LOGIC_VECTOR(0 DOWNTO 0);
count_up    : in std_logic;
latch_data  : in std_logic;

out_data  : out std_logic_vector(7 downto 0);
clk_is_okay : out std_logic
);
end memory_top_with_ila;

architecture Behavioral of memory_top_with_ila is
component mem_test_top is
PORT(
inp_addr : in std_logic_vector(12 downto 0);
inp_data : in std_logic_vector(7 downto 0);
inp_wr_en : in STD_LOGIC_VECTOR(0 DOWNTO 0);
out_data  : out std_logic_vector(7 downto 0);
sys_clk_in : in std_logic;
clk_is_okay : out std_logic;
out_clock : out std_logic;
distrib_mem_out_data  : out std_logic_vector(7 downto 0)
);
end component;

component ila_0 
port (
clk             : in std_logic;
probe0          : in std_logic_vector(12 downto 0);
probe1          : in std_logic_vector(7 downto 0);
probe2          : in std_logic_vector(7 downto 0);
probe3          : in std_logic_vector(0 downto 0);
probe4          : in std_logic_vector(0 downto 0);
probe5          : in std_logic_vector(0 downto 0);
probe6          : in std_logic_vector(0 downto 0);
probe7          : in std_logic_vector(7 downto 0)

);
end component;

signal inp_addr_ila : std_logic_vector(12 downto 0);
signal inp_data_ila : std_logic_vector(7 downto 0);
signal out_data_ila : std_logic_vector(7 downto 0);
signal inp_wr_en_ila : std_logic_vector(0 downto 0);
signal out_clock_ila : std_logic;
signal clk_is_okay_ila : std_logic_vector(0 downto 0);
signal count_up_ila : std_logic_vector(0 downto 0);
signal latch_data_ila : std_logic_vector(0 downto 0);
signal distrib_mem_out_data_ila : std_logic_vector(7 downto 0);
signal my_local_addr_counter : std_logic_vector(12 downto 0);
begin

memory_top_inst: mem_test_top 
PORT map (
inp_addr   => inp_addr_ila ,
inp_data   => inp_data_ila ,
inp_wr_en  => inp_wr_en_ila,
out_data   => out_data_ila,
sys_clk_in => sys_clk_in,
clk_is_okay => clk_is_okay_ila(0),
out_clock   => out_clock_ila,
distrib_mem_out_data => distrib_mem_out_data_ila 
 
);

--Connect input signals
inp_addr_ila    <= my_local_addr_counter  ;   
inp_data_ila    <= inp_data  ;   
inp_wr_en_ila   <= inp_wr_en ;   
latch_data_ila(0)  <= latch_data;
count_up_ila(0)    <= count_up;

ila_inst : ila_0
port map(
clk => out_clock_ila,
probe0 =>   inp_addr_ila ,
probe1 =>   inp_data_ila ,
probe2 =>   out_data_ila,
probe3 =>   clk_is_okay_ila, 
probe4 =>   inp_wr_en_ila,
probe5 =>   count_up_ila,
probe6 =>   latch_data_ila,
probe7 =>   distrib_mem_out_data_ila
);


--Connect ouputs
clk_is_okay <= clk_is_okay_ila(0);
out_data        <= out_data_ila;  

--Address counter
process(out_clock_ila,rst_board)
begin
    if(rst_board = '0') then
        my_local_addr_counter      <= (others =>'0');
    elsif(rising_edge(out_clock_ila)) then
        if(count_up = '1') then
            my_local_addr_counter      <= std_logic_vector(unsigned(my_local_addr_counter) + 1);
        else
            my_local_addr_counter      <= std_logic_vector(unsigned(my_local_addr_counter) - 1);
        end if;
    end if;
end process;
end Behavioral;
